﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlServerCe;

namespace sql_demo
{
    public partial class Form1 : Form
    {
        SqlCeConnection con = new SqlCeConnection(@"Data Source=Program Files\\sql_demo\\sql_demo.sdf");   ///< location of data base on device
        public Form1()
        {
            try
            {
                /// open the connection between your database and appliation
                con.Open();                                                     
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            InitializeComponent();
        }

        private void btnShow_Click(object sender, EventArgs e)
        {
            /// sql query to select demo_table
            SqlCeCommand cmd = new SqlCeCommand("SELECT * FROM demo_table", con);
            SqlCeDataReader reader = cmd.ExecuteReader();
            DataTable table = new DataTable();
            table.Columns.Add("ID", typeof(int));              
            table.Columns.Add("NAME", typeof(string));       
            /// reads data from "demo_table" and fill "table" until last row
            while (reader.Read())
            {
                table.Rows.Add(reader.GetInt32(0), reader.GetString(1));
            }
            reader.Close();
            dataGrid1.DataSource = table;
        }

        private void btnInsert_Click(object sender, EventArgs e)
        {
            int inserQueryCheck = 0;
            /// sql query to insert in database
            SqlCeCommand cmd = new SqlCeCommand("INSERT INTO demo_table(ID ,NAME) VALUES (@Id,@Name)", con);
            cmd.Parameters.AddWithValue("@Id", txtId.Text);
            cmd.Parameters.AddWithValue("@Name", txtName.Text);
            if (txtId.Text.Trim().Length != 0 & txtName.Text.Trim().Length != 0)
            {
                try
                {
                    /// exexcute cmd so that all query command executes
                    inserQueryCheck = cmd.ExecuteNonQuery();
                    if (inserQueryCheck > 0)
                    {
                        MessageBox.Show("INSERTED");
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
            else
            {
                MessageBox.Show("Please Enter ID and NAME");
            }
            displayTable();
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            int deleteRowIndex = 0;
            int deleteQueryCheck = 0;
            /// sql query to delete from demo_table
            SqlCeCommand cmd = new SqlCeCommand("DELETE FROM demo_table WHERE ID=@Id AND NAME=@Name", con);
            deleteRowIndex = dataGrid1.CurrentRowIndex;
            if (deleteRowIndex >= 0)
            {
                txtId.Text = dataGrid1[deleteRowIndex, 0].ToString();
                txtName.Text = dataGrid1[deleteRowIndex, 1].ToString();
                cmd.Parameters.AddWithValue("@Id", txtId.Text);
                cmd.Parameters.AddWithValue("@Name", txtName.Text);
                try
                {   
                    deleteQueryCheck = cmd.ExecuteNonQuery();
                    if (deleteQueryCheck > 0)
                    {
                        MessageBox.Show("DELETED");
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
                displayTable();
            }
            else 
            {
                MessageBox.Show("Empty Database");
            }
        }

        private void btnModify_Click(object sender, EventArgs e)
        {
            int modifyRowIndex = 0;
            int modifyQueryCheck = 0;
            modifyForm otherForm = new modifyForm();

            /// sql query to modifiy demo_table
            SqlCeCommand cmd = new SqlCeCommand("UPDATE demo_table SET ID=@Id,NAME=@Name WHERE ID=@uId", con);
            modifyRowIndex = dataGrid1.CurrentRowIndex;
            txtId.Text = dataGrid1[modifyRowIndex, 0].ToString();               
            cmd.Parameters.AddWithValue("@uId", txtId.Text);            
            otherForm.ShowDialog();    
            cmd.Parameters.AddWithValue("@Id", otherForm.txtmId.Text);  
            cmd.Parameters.AddWithValue("@Name", otherForm.txtmName.Text);
            if (otherForm.txtmId.Text.Trim().Length != 0 && otherForm.txtmName.Text.Trim().Length!=0)
            {
                try
                {
                    modifyQueryCheck = cmd.ExecuteNonQuery();
                    if (modifyQueryCheck > 0)
                    {
                        MessageBox.Show("MODIFIED");
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
            else
            {
                MessageBox.Show("Please Enter ID and NAME");
            }
            displayTable();
        }
        private void clearTexbox()
        {
            txtId.Text = string.Empty;
            txtName.Text=string.Empty;
        }

        private void btnSearch_Click(object sender, EventArgs e)
        {
            int searchRowIndex = 0;

            /// sql query to search demo_table
            SqlCeCommand cmd = new SqlCeCommand("SELECT * FROM demo_table WHERE ID='" + txtId.Text + "'", con);
            if (txtId.Text.Trim().Length != 0)
            {
                SqlCeDataReader reader = cmd.ExecuteReader();
                DataTable table = new DataTable();
                table.Columns.Add("ID", typeof(int));
                table.Columns.Add("NAME", typeof(string));
                while (reader.Read())
                {
                    table.Rows.Add(reader.GetInt32(0), reader.GetString(1));
                }

                reader.Close();
                dataGrid1.DataSource = table;
                searchRowIndex = dataGrid1.CurrentRowIndex;
                if (searchRowIndex < 0)
                {
                    MessageBox.Show("No Result Found");
                }
            }

            else
            {
                MessageBox.Show("Please Enter valid Id");
            }
            clearTexbox();
        }

        private void btnSort_Click(object sender, EventArgs e)
        {
            /// sql query to sort demo_table
            SqlCeCommand cmd = new SqlCeCommand("SELECT * FROM demo_table ORDER BY ID", con);
            cmd.ExecuteNonQuery();
            SqlCeDataReader reader = cmd.ExecuteReader();
            DataTable table = new DataTable();
            table.Columns.Add("ID", typeof(int));
            table.Columns.Add("NAME", typeof(string));
            while (reader.Read())
            {
                table.Rows.Add(reader.GetInt32(0), reader.GetString(1));
            }
            reader.Close();
            dataGrid1.DataSource = table;
            clearTexbox();
        }

        /// function to display table in data grid
        private void displayTable()
        {
            SqlCeCommand cmd = new SqlCeCommand("SELECT * FROM demo_table", con);
            SqlCeDataReader reader = cmd.ExecuteReader();
            DataTable table = new DataTable();
            table.Columns.Add("ID", typeof(int));                                   
            table.Columns.Add("NAME", typeof(string));                              
            while (reader.Read())
            {
                table.Rows.Add(reader.GetInt32(0), reader.GetString(1));
            }
            reader.Close();
            dataGrid1.DataSource = table;
            clearTexbox();
        }
  
    }
}